"use strict";

var _random = _interopRequireDefault(require("@reactioncommerce/random"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var MongoID = {};

MongoID._looksLikeObjectID = function (str) {
  return str.length === 24 && str.match(/^[0-9a-f]*$/);
};

MongoID.ObjectID = /*#__PURE__*/function () {
  function ObjectID(hexString) {
    _classCallCheck(this, ObjectID);

    // random-based impl of Mongo ObjectID
    if (hexString) {
      var lowerCaseHexString = hexString.toLowerCase();

      if (!MongoID._looksLikeObjectID(lowerCaseHexString)) {
        throw new Error('Invalid hexadecimal string for creating an ObjectID');
      } // meant to work with _.isEqual(), which relies on structural equality


      this._str = lowerCaseHexString;
    } else {
      this._str = _random["default"].hexString(24);
    }
  }

  _createClass(ObjectID, [{
    key: "equals",
    value: function equals(other) {
      return other instanceof MongoID.ObjectID && this.valueOf() === other.valueOf();
    }
  }, {
    key: "toString",
    value: function toString() {
      return "ObjectID(\"".concat(this._str, "\")");
    }
  }, {
    key: "clone",
    value: function clone() {
      return new MongoID.ObjectID(this._str);
    } // eslint-disable-next-line class-methods-use-this

  }, {
    key: "typeName",
    value: function typeName() {
      return 'oid';
    }
  }, {
    key: "getTimestamp",
    value: function getTimestamp() {
      return Number.parseInt(this._str.substr(0, 8), 16);
    }
  }, {
    key: "valueOf",
    value: function valueOf() {
      return this._str;
    }
  }, {
    key: "toJSONValue",
    value: function toJSONValue() {
      return this.valueOf();
    }
  }, {
    key: "toHexString",
    value: function toHexString() {
      return this.valueOf();
    }
  }]);

  return ObjectID;
}();